//::///////////////////////////////////////////////
//:: Sneak Attack Include Script
//:: kprc_inc_sneakattack (based on cmi_inc_sneakattack)
//:: Purpose:
//:: Created By: Kaedrin (Matt)
//:: Created On: January 1, 2008
//:: Updated By: Lavallet (Kryukov I.)
//:: Updated On: September 18, 2018
//:://////////////////////////////////////////////

#include "nw_i0_generic"

//void main() {}

////////////////////////////////////////////////////////////////////////////
//|¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯|//
//|                             CONSTANTS                                |//
//|______________________________________________________________________|//
////////////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------------
// Constants for 'classes.2da' entries
//--------------------------------------------------------------------------
const int CLASS_BLACK_FLAME_ZEALOT = 111;
const int CLASS_NIGHTSONG_ENFORCER = 115;
const int CLASS_THUG = 116;
const int CLASS_DIVINE_SEEKER = 119;
const int CLASS_SKULLCLAN_HUNTER = 127;
const int CLASS_DARK_LANTERN = 128;
const int CLASS_NIGHTSONG_INFILTRATOR = 129;
const int CLASS_SHADOWBANE_STALKER = 133;
const int CLASS_UNDERDARK_MARAUDER = 141;
const int CLASS_AVENGER = 142;
const int CLASS_NINJA = 144;
const int CLASS_GHOST_FACED_KILLER = 145;
const int CLASS_DAGGERSPELL_MAGE = 147;
const int CLASS_DAGGERSPELL_SHAPER = 148;
const int CLASS_SCOUT = 149;
const int CLASS_WILD_STALKER = 150;
const int CLASS_DREAD_COMMANDO = 166;
const int CLASS_WHIRLING_DERVISH = 181;

//--------------------------------------------------------------------------
// Constants for 'feat.2da' entries
//--------------------------------------------------------------------------
const int FEAT_DARING_OUTLAW = 3319;
const int FEAT_SWIFT_AMBUSHER = 3710;
const int FEAT_SWIFT_HUNTER = 3711;
const int FEAT_CHARNAG_WAY_SHADOW = 3772;

////////////////////////////////////////////////////////////////////////////
//|¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯|//
//|                             PROTOTYPES                               |//
//|______________________________________________________________________|//
////////////////////////////////////////////////////////////////////////////

//
int GetSneakLevels(object oTarget);
//
int GetTotalSneakDice(object oTarget, object oSneakAttacker);
//
int IsTargetConcealed(object oTarget, object oSneakAttacker);
//
int IsTargetValidForSneakAttack(object oTarget, object oSneakAttacker);
//
int EvaluateSneakAttack(object oTarget, object oSneakAttacker);

////////////////////////////////////////////////////////////////////////////
//|¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯|//
//|                            DEFINITIONS                               |//
//|______________________________________________________________________|//
////////////////////////////////////////////////////////////////////////////

//
int GetSneakLevels(object oTarget)
{
	int nClassLevel = 0;
	int nSneakLevels = 0;

	// Stock classes

	nClassLevel = GetLevelByClass(CLASS_TYPE_INVISIBLE_BLADE, oTarget);
	if (nClassLevel > 1)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_TYPE_ARCANETRICKSTER, oTarget);
	if (nClassLevel > 1)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_TYPE_ASSASSIN, oTarget);
	if (nClassLevel > 0)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_TYPE_BLACKGUARD, oTarget);
	if (nClassLevel > 3)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_NWNINE_WARDER, oTarget);
	if (nClassLevel > 2)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_TYPE_ROGUE, oTarget);
	if (nClassLevel > 0)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_TYPE_SHADOWTHIEFOFAMN, oTarget);
	if (nClassLevel > 0)
	{
		nSneakLevels += nClassLevel;
	}

	// Begin my classes

	nClassLevel = GetLevelByClass(CLASS_AVENGER, oTarget);
	if (nClassLevel > 0)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_BLACK_FLAME_ZEALOT, oTarget);
	if (nClassLevel > 2)
	{
		nSneakLevels += nClassLevel;
	}

	//1.18
	nClassLevel = GetLevelByClass(CLASS_DIVINE_SEEKER, oTarget);
	if (nClassLevel > 1)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_NIGHTSONG_INFILTRATOR, oTarget);
	if (nClassLevel > 3)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_NIGHTSONG_ENFORCER, oTarget);
	if (nClassLevel > 0)
	{
		nSneakLevels += nClassLevel;
	}

	//1.25
	nClassLevel = GetLevelByClass(CLASS_DREAD_COMMANDO, oTarget);
	if (nClassLevel > 0)
	{
		nSneakLevels += nClassLevel;
	}

	//1.33
	nClassLevel = GetLevelByClass(CLASS_SKULLCLAN_HUNTER, oTarget);
	if (nClassLevel > 2)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_WHIRLING_DERVISH, oTarget);
	if (nClassLevel > 2)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_DARK_LANTERN, oTarget);
	if (nClassLevel > 0)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_THUG, oTarget);
	if (nClassLevel > 0)
	{
		nSneakLevels += nClassLevel;
	}

	//1.35
	nClassLevel = GetLevelByClass(CLASS_SHADOWBANE_STALKER, oTarget);
	if (nClassLevel > 2)
	{
		nSneakLevels += nClassLevel;
	}

	//1.39
	nClassLevel = GetLevelByClass(CLASS_DAGGERSPELL_MAGE, oTarget);
	if (nClassLevel > 2)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_DAGGERSPELL_SHAPER, oTarget);
	if (nClassLevel > 2)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_NINJA, oTarget);
	if (nClassLevel > 0)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_SCOUT, oTarget);
	if (nClassLevel > 0)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_WILD_STALKER, oTarget);
	if (nClassLevel > 1)
	{
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_GHOST_FACED_KILLER, oTarget);
	if (nClassLevel > 1)
	{
		nSneakLevels += nClassLevel;
	}

	//1.41
	nClassLevel = GetLevelByClass(CLASS_UNDERDARK_MARAUDER, oTarget);
	if (nClassLevel > 0 && GetHasFeat(FEAT_CHARNAG_WAY_SHADOW, oTarget, TRUE))
	{
		nSneakLevels += nClassLevel;
	}

	return nSneakLevels;
}

//
int GetTotalSneakDice(object oTarget, object oSneakAttacker)
{
	int nDice = 0;
	int nClassLevel = 0;
	int nSneakLevels = 0;

	//Added by Lavallet
	int nRogue = GetLevelByClass(CLASS_TYPE_ROGUE, oSneakAttacker) + GetLevelByClass(CLASS_NINJA, oSneakAttacker);
	int nDaringOutlawCap = GetLocalInt(GetModule(), "DaringOutlawCap");

	// Stock classes

	nClassLevel = GetLevelByClass(CLASS_TYPE_INVISIBLE_BLADE, oSneakAttacker);
	if (nClassLevel > 0)
	{
		nDice += (nClassLevel + 1) / 2;
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_TYPE_ARCANETRICKSTER, oSneakAttacker);
	if (nClassLevel > 1)
	{
		nDice += nClassLevel / 2;
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_TYPE_ASSASSIN, oSneakAttacker);
	if (nClassLevel > 0)
	{
		nDice += (nClassLevel + 1) / 2;
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_TYPE_BLACKGUARD, oSneakAttacker);
	if (nClassLevel > 3)
	{
		nDice += (nClassLevel - 1) / 3;
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_NWNINE_WARDER, oSneakAttacker);
	if (nClassLevel > 2)
	{
		nDice += 2;
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_TYPE_ROGUE, oSneakAttacker);
	if (nClassLevel > 0)
	{
		nDice += (nClassLevel + 1) / 2;
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_TYPE_SHADOWTHIEFOFAMN, oSneakAttacker);
	if (nClassLevel > 0)
	{
		nDice += (nClassLevel + 1) / 2;
		nSneakLevels += nClassLevel;
	}

	// Begin my classes

	nClassLevel = GetLevelByClass(CLASS_AVENGER, oSneakAttacker);
	if (nClassLevel > 0)
	{
		nDice += (nClassLevel + 1) / 2;
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_BLACK_FLAME_ZEALOT, oSneakAttacker);
	if (nClassLevel > 2)
	{
		nDice += nClassLevel / 3;
		nSneakLevels += nClassLevel;
	}

	//1.18
	nClassLevel = GetLevelByClass(CLASS_DIVINE_SEEKER, oSneakAttacker);
	if (nClassLevel > 1)
	{
		nDice += (nClassLevel + 1) / 3;
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_NIGHTSONG_INFILTRATOR, oSneakAttacker);
	if (nClassLevel > 3)
	{
		nDice += nClassLevel / 4;
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_NIGHTSONG_ENFORCER, oSneakAttacker);
	if (nClassLevel > 0)
	{
		nDice += (nClassLevel + 2) / 3;
		nSneakLevels += nClassLevel;
	}

	//1.25
	nClassLevel = GetLevelByClass(CLASS_DREAD_COMMANDO, oSneakAttacker);
	if (nClassLevel > 0)
	{
		nDice += (nClassLevel + 1) / 2;
		nSneakLevels += nClassLevel;
	}

	//1.33
	nClassLevel = GetLevelByClass(CLASS_SHADOWBANE_STALKER, oSneakAttacker);
	if (nClassLevel > 2)
	{
		nDice += nClassLevel / 3;
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_SKULLCLAN_HUNTER, oSneakAttacker);
	if (nClassLevel > 2)
	{
		nDice += nClassLevel / 3;
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_WHIRLING_DERVISH, oSneakAttacker);
	if (nClassLevel > 2)
	{
		nDice += nClassLevel / 3;
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_DARK_LANTERN, oSneakAttacker);
	if (nClassLevel > 0)
	{
		nDice += (nClassLevel / 2 );
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_THUG, oSneakAttacker);
	if (nClassLevel > 0)
	{
		nDice += (nClassLevel / 2 );
		nSneakLevels += nClassLevel;
	}

	//1.39
	nClassLevel = GetLevelByClass(CLASS_DAGGERSPELL_MAGE, oSneakAttacker);
	if (nClassLevel > 0)
	{
		nDice += (nClassLevel / 3);
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_DAGGERSPELL_SHAPER, oSneakAttacker);
	if (nClassLevel > 0)
	{
		nDice += (nClassLevel / 3);
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_NINJA, oSneakAttacker);
	if (nClassLevel > 0)
	{
		nDice += (nClassLevel + 1) / 2;
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_SCOUT, oSneakAttacker);
	if (nClassLevel > 0)
	{
		//Added by Lavallet
		if (nRogue > 0 && GetHasFeat(FEAT_SWIFT_AMBUSHER, oSneakAttacker, TRUE))
			nDice += (nClassLevel + 1) / 2;
		else
			nDice += (nClassLevel + 3) / 4;

		if (GetHasFeat(FEAT_SWIFT_HUNTER, oSneakAttacker, TRUE))
		{
			int nRanger = GetLevelByClass(CLASS_TYPE_RANGER, oSneakAttacker);
			nDice += (nRanger + 3) / 4;
		}

		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_WILD_STALKER, oSneakAttacker);
	if (nClassLevel > 0)
	{
		nDice += (nClassLevel + 2) / 4;
		nSneakLevels += nClassLevel;
	}

	nClassLevel = GetLevelByClass(CLASS_GHOST_FACED_KILLER, oSneakAttacker);
	if (nClassLevel > 0)
	{
		nDice += (nClassLevel + 1) / 3;
		nSneakLevels += nClassLevel;
	}

	//1.41
	nClassLevel = GetLevelByClass(CLASS_UNDERDARK_MARAUDER, oSneakAttacker);
	if (nClassLevel > 0 && GetHasFeat(FEAT_CHARNAG_WAY_SHADOW, oSneakAttacker, TRUE))
	{
		nDice += (nClassLevel + 1) / 2;
		nSneakLevels += nClassLevel;
	}

	//Added by Lavallet
	nClassLevel = GetLevelByClass(CLASS_TYPE_SWASHBUCKLER, oSneakAttacker);
	if (nRogue > 0 && nClassLevel > 0 && GetHasFeat(FEAT_DARING_OUTLAW, oSneakAttacker, TRUE))
	{
		nClassLevel = (nDaringOutlawCap > 0 ? (nClassLevel > nDaringOutlawCap ? nDaringOutlawCap : nClassLevel) : nClassLevel);
		nDice += (nClassLevel + 1) / 2;
	}

	nDice += GetHasFeat(FEAT_EPIC_IMPROVED_SNEAK_ATTACK_1, oSneakAttacker, TRUE) +
			 GetHasFeat(FEAT_EPIC_IMPROVED_SNEAK_ATTACK_2, oSneakAttacker, TRUE) +
			 GetHasFeat(FEAT_EPIC_IMPROVED_SNEAK_ATTACK_3, oSneakAttacker, TRUE) +
			 GetHasFeat(FEAT_EPIC_IMPROVED_SNEAK_ATTACK_4, oSneakAttacker, TRUE) +
			 GetHasFeat(FEAT_EPIC_IMPROVED_SNEAK_ATTACK_5, oSneakAttacker, TRUE) +
			 GetHasFeat(FEAT_EPIC_IMPROVED_SNEAK_ATTACK_6, oSneakAttacker, TRUE) +
			 GetHasFeat(FEAT_EPIC_IMPROVED_SNEAK_ATTACK_7, oSneakAttacker, TRUE) +
			 GetHasFeat(FEAT_EPIC_IMPROVED_SNEAK_ATTACK_8, oSneakAttacker, TRUE) +
			 GetHasFeat(FEAT_EPIC_IMPROVED_SNEAK_ATTACK_9, oSneakAttacker, TRUE) +
			 GetHasFeat(FEAT_EPIC_IMPROVED_SNEAK_ATTACK_10, oSneakAttacker, TRUE);

	if (GetHasFeat(FEAT_IMPROVED_UNCANNY_DODGE, oTarget, TRUE))
	{
		if ( nSneakLevels > (GetSneakLevels(oTarget) + 3) ) // Need to be >= Target Dice + 4
		{
			return nDice;
		}
		else
			return 0;
	}

	return nDice;
}

//
int IsTargetConcealed(object oTarget, object oSneakAttacker)
{
	int bIsConcealed = FALSE;

	int bAttackerHasTrueSight = GetHasEffect(EFFECT_TYPE_TRUESEEING, oSneakAttacker);
	int bAttackerCanSeeInvisble = GetHasEffect(EFFECT_TYPE_SEEINVISIBLE, oSneakAttacker);
	int bAttackerUltraVision = GetHasEffect(EFFECT_TYPE_ULTRAVISION, oSneakAttacker);

	if(GetHasFeat(FEAT_EPIC_SELF_CONCEALMENT_50, oTarget) )
		bIsConcealed = TRUE;
	else if(GetHasFeat(FEAT_EPIC_SELF_CONCEALMENT_40, oTarget) )
		bIsConcealed = TRUE;
	else if(GetHasFeat(FEAT_EPIC_SELF_CONCEALMENT_30, oTarget) )
		bIsConcealed = TRUE;
	else if(GetHasFeat(FEAT_EPIC_SELF_CONCEALMENT_20, oTarget) )
		bIsConcealed = TRUE;
	else if(GetHasFeat(FEAT_EPIC_SELF_CONCEALMENT_10, oTarget) )
		bIsConcealed = TRUE;
	else if(GetStealthMode(oTarget) == STEALTH_MODE_ACTIVATED && !GetObjectSeen(oTarget, oSneakAttacker) )
		bIsConcealed = TRUE;
	else if(GetHasEffect(EFFECT_TYPE_SANCTUARY, oTarget) && !bAttackerHasTrueSight )
		bIsConcealed = TRUE;
	else if(GetHasEffect(EFFECT_TYPE_INVISIBILITY, oTarget) && !bAttackerHasTrueSight && !bAttackerCanSeeInvisble )
		bIsConcealed = TRUE;
	else if(GetHasEffect(EFFECT_TYPE_DARKNESS, oTarget) && !bAttackerHasTrueSight && !bAttackerUltraVision)
		bIsConcealed = TRUE;
	else if(GetHasFeatEffect(FEAT_EMPTY_BODY, oTarget) )
		bIsConcealed = TRUE;
	else if(GetHasEffect(EFFECT_TYPE_ETHEREAL, oTarget) && !bAttackerHasTrueSight && !bAttackerCanSeeInvisble  )
		bIsConcealed = TRUE;
	else if(GetHasEffect(EFFECT_TYPE_CONCEALMENT, oTarget) && !bAttackerHasTrueSight)
		bIsConcealed = TRUE;

	return bIsConcealed;
}

// Sneak Attack can't be used against targets with concealment
int IsTargetValidForSneakAttack(object oTarget, object oSneakAttacker)
{
	int nEpicPrecision = FALSE;
	object oAttackedByTarget = GetAttackTarget(oTarget);

	//Don't bother if the target is out of range
	if (GetDistanceBetween(oSneakAttacker, oTarget) < FeetToMeters(30.0f))
	{
		//Don't bother if the target is immune
		if (GetIsImmune(oTarget, IMMUNITY_TYPE_SNEAK_ATTACK, oSneakAttacker) || GetIsImmune(oTarget, IMMUNITY_TYPE_CRITICAL_HIT, oSneakAttacker))
		{
			if (GetHasFeat(2128, oSneakAttacker))
				nEpicPrecision = TRUE;
			else
				return FALSE;
		}
		//Don't bother if the target is concealed
		if (IsTargetConcealed(oTarget, oSneakAttacker))
		{
			return FALSE;
		}

		if (oAttackedByTarget == oSneakAttacker) //Head to Head requires the target be unable to defend themself
		{
			//Should I add Daze?  Need to test being dazed near a creature with sneak
			//to see how the official sneak attack is handled.
			//Need to add any future spells that knockdown here
			if (
			GetHasEffect( EFFECT_TYPE_STUNNED, oTarget)
			|| GetHasEffect( EFFECT_TYPE_BLINDNESS, oTarget)
			|| GetHasEffect( EFFECT_TYPE_PARALYZE, oTarget)
			|| GetHasEffect( EFFECT_TYPE_SLEEP, oTarget)
			|| GetHasEffect( EFFECT_TYPE_PETRIFY, oTarget)
			|| GetHasEffect( EFFECT_TYPE_CUTSCENE_PARALYZE, oTarget)
		//	|| GetHasFeatEffect( FEAT_IMPROVED_KNOCKDOWN, oTarget)
		//	|| GetHasFeatEffect( FEAT_KNOCKDOWN, oTarget)
		//	|| GetHasSpellEffect( SPELL_SPELLABILITY_Clap_Thunder, oTarget) // Clap of Thunder does a knockdown
			)
			{
				if (nEpicPrecision)
					return 2;
				else
					return TRUE;
			}
			else
			{
				// Need code here for invisible caster and target seeing invisble
				return FALSE;
			}
		}
		else
		{
			if (nEpicPrecision)
				return 2;
			else
				return TRUE;  // Should check if flanking but this is good for now.
		}

	} // end distance check
	return FALSE;
}

//
int EvaluateSneakAttack(object oTarget, object oSneakAttacker)
{

	int nSneakAttackSpells = GetLocalInt(GetModule(), "SneakAttackSpells");

	if (!nSneakAttackSpells)
		return 0;

	int nIsTargetValidForSneakAttack = IsTargetValidForSneakAttack(oTarget, oSneakAttacker);
	if (nIsTargetValidForSneakAttack)
	{
		int nDice = GetTotalSneakDice(oTarget, oSneakAttacker);

		if (nDice > 0)
		{
			if (nIsTargetValidForSneakAttack == 2)
				nDice = nDice / 2;
			FloatingTextStringOnCreature("Скрытая атака!", oSneakAttacker);
			SendMessageToPC(oSneakAttacker, "Скрытая атака!");
			return d6(nDice);
		}
		else
			return 0;
	}
	return 0;

}